// mprog.h
// (C) Copyright 1998,2001  Jed Margolin  All Rights Reserved
// Monitor Test Patterns 


// For Lissajous sine table, 360 degrees/DEG entries. Binary multiples only
#define DEG 2048 	
//------------------------------------------------------------------------
struct ctable		// color table
{
	float r,g,b;	
};

	
struct ctable lctable[8]=
{
	{ 0.0f,0.0f,0.0f }, // color 0  Black
	{ 1.0f,0.0f,0.0f },	// color 1  Red
	{ 0.0f,1.0f,0.0f },	// color 2  Green
	{ 0.0f,0.0f,1.0f },	// color 3  Blue
	{ 0.0f,1.0f,1.0f },	// color 4  Cyan
	{ 1.0f,0.0f,1.0f },	// color 5  Magenta
	{ 1.0f,1.0f,0.0f },	// color 6  Yellow
	{ 1.0f,1.0f,1.0f },	// color 7  White
};	


#define BLACK	0
#define RED		1
#define GREEN	2
#define BLUE	3
#define CYAN	4
#define MAGENTA 5
#define YELLOW	6
#define WHITE	7
//------------------------------------------------------------------------
// Menu Table

#define NUM_ENTRIES	8
#define XM1		3
#define XM2		43

int mexit(void);
int lissajous_pattern(void);
int cbars_pattern(void);
int dot_pattern(void);
int chatch_pattern(void);
int hvreg_test(void);
int help(void);

struct tentry 
{
	int xpos;		// Menu Coordinates
	int ypos;		
	char msg[80];	// Menu Message
	int (*pgm)();	// Function to call
    int speed;		// Slow down parameter for System Speed
};
	
struct tentry mtable[NUM_ENTRIES]=
{
   { XM1, 6,  "EXIT", mexit, 0 },
   { XM1, 8,  "Lissajous Pattern: Fast Systems", lissajous_pattern, 8 },
   { XM1, 9,  "Lissajous Pattern: Slow Systems", lissajous_pattern, 1 },
   { XM1, 10, "Color Bar Test Pattern", cbars_pattern, 0 },
   { XM1, 11, "Cross Hatch Pattern", chatch_pattern,0  },
   { XM1, 12, "Dot Pattern", dot_pattern, 0 },
   { XM1, 13, "HV Regulation Test", hvreg_test, 8 },
   { XM1, 15, "Instructions", help, 0 },
};
// -----------------------------------------------------------------------
struct dirstr 
{
	int xpos;
	int ypos;		    // Message Coordinates 
	int color;
	char msg[80];		// Message
};

#define NUM_INSTR	15	
struct dirstr dirmsgs[NUM_INSTR]=
{
   { 3,1,MAGENTA,"Directions:" },
   { 3,3,WHITE,"Lissajous Patterns" },
   { 5,4,YELLOW,"<Right Arrow> increases the phase rotation by a small amount." },
   { 5,5,YELLOW,"<Left Arrow> decreases the phase rotation by a small amount." },
   { 5,6,YELLOW,"<Up Arrow> increases the phase rotation by an integer amount." },
   { 5,7,YELLOW,"<Dn Arrow> decreases the phase rotation by an integer amount." },
   { 5,8,YELLOW,"PgUp and PgDn change the color of the figure." },
   { 5,9,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change the color of the background." },
   { 3,11,WHITE,"Color Bars are the combinations of Red, Green, and Blue." },
   { 3,13,WHITE,"Crosshatch and Dot Patterns show how well the monitor is converged." },
   { 5,14,YELLOW,"PgUp and PgDn change the color of grid lines or dots." },
   { 5,15,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change the color of the background." },
   { 3,17,WHITE,"HV Test challenges Monitor HV Regulation by changing the beam current." },
   { 5,18,YELLOW,"PgUp and PgDn change Color 1." },
   { 5,19,YELLOW,"Ctl<PgUp> and Ctl<PgDn> change Color 2." },
};

 
/* Virtual Keys:
	VK_SPACE
	VK_PRIOR
	VK_NEXT 
	VK_END  
	VK_HOME 
	VK_LEFT 
	VK_UP   
	VK_RIGHT
	VK_DOWN 
	VK_SELECT
	VK_PRINT 
	VK_EXECUTE
	VK_SNAPSHOT
	VK_INSERT  
	VK_DELETE  
*/
